namespace GraphicsManager.Globals;

public static class EXT
{
    public static T[] RemoveAt<T>(this T[] source, int index)
    {
        if (source.Length == 1) return Array.Empty<T>();
        T[] dest = new T[source.Length - 1];
        if( index > 0 )
            Array.Copy(source, 0, dest, 0, index);

        if( index < source.Length - 1 )
            Array.Copy(source, index + 1, dest, index, source.Length - index - 1);

        return dest;
    }
    
    public static T[] Add<T>(this T[] source, T Object)
    {
        T[] dest = new T[source.Length + 1];
        return source.Concat(new T[1] { Object }).ToArray();
    }
}